package com.ruoyi.domain;

import com.baomidou.mybatisplus.annotation.*;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * 
 * @TableName t_test_plan_record
 */
@TableName(value ="t_test_plan_record")
@Data
public class TTestPlanRecord{
    /**
     * 主键
     */
    @ApiModelProperty("主键")
    @TableId(type = IdType.ASSIGN_ID)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /**
     * 被检车企ID
     */
    @ApiModelProperty("被检车企ID")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long inspectCarCompanyId;

    /**
     * 被检车企名称
     */
    @ApiModelProperty("被检车企名称")
    @TableField(exist = false)
    private String inspectCarCompanyName;

    /**
     * 车辆型号
     */
    @ApiModelProperty("车辆型号")
    private String carModel;


    /**
     * 文件路径
     */
    @ApiModelProperty("文件路径")
    private String fileUrl;

    /**
     * 测试结果
     */
    @ApiModelProperty("测试结果")
    private String testResult;


    /**
     * 检测机构id
     */
    @ApiModelProperty("检测机构id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long testOrganizationId;

    /**
     * 检测机构名称
     */
    @ApiModelProperty("检测机构名称")
    @TableField(exist = false)
    private String deptName;

    /**
     * 关联的检验项目逗号分隔id
     */
    @ApiModelProperty("关联的检验项目逗号分隔id")
    private String inspectionItem;

    /**
     * 关联的用例编号逗号分隔id
     */
    @ApiModelProperty("关联的用例编号")
    private String useCaseNo;

    /**
     * 标准id
     */
    @ApiModelProperty("标准id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long inspectionStandardId;

    /**
     * 标准名称
     */
    @ApiModelProperty("标准名称")
    @TableField(exist = false)
    private String inspectionStandardName;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty("指定的方案")
    private String specifyPlan;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

}