package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.ReviewDetails;
import com.ruoyi.domain.ReviewScene;
import com.ruoyi.domain.ReviewStandard;
import com.ruoyi.web.request.ReviewSceneFindListRequest;
import com.ruoyi.web.response.GetSceneListResponse;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ReviewSceneMapper extends BaseMapper<ReviewScene> {
    List<ReviewScene> findByDetailsList(@Param("reviewDetailsList") List<ReviewDetails> reviewDetailsList);

    // 根据细则id查询场景列表
    List<ReviewScene> findByDetailId(@Param("detailId") Long detailId);

    // 查询场景列表
    List<ReviewScene> findList(ReviewSceneFindListRequest request);

    List<GetSceneListResponse> getSceneListById(@Param("id") Long id);

    // 根据细则ID查询审核场景（Scene）列表
    List<ReviewScene> selectSceneListByDetailsId(Long detailsId);
}
