package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.Standard;
import com.ruoyi.web.request.GetChapterListRequest;
import com.ruoyi.web.request.StandardListRequest;
import com.ruoyi.web.response.ReviewStandardChapterListResponse;
import com.ruoyi.web.response.StandardDTO;
import com.ruoyi.web.response.StandardTypeListResponse;
import com.ruoyi.web.response.StandardVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface StandardMapper extends BaseMapper<Standard> {

    // 分页查询
    List<Standard> findList(StandardListRequest request);

    // 根据id查询
    Standard findListById(@Param("id") Long Id);

    //查询全部
    List<Standard> selectListAll();

    /**
     * 标准库分页查询(可选用标准列表)
     * @param request
     * @return
     */
    List<Standard> findStandardList(StandardListRequest request);


    List<StandardDTO> getStandardDTOList();

    List<String> getTypeList(@Param("getChapterListRequest") GetChapterListRequest getChapterListRequest);

    List<ReviewStandardChapterListResponse> getChapterList(@Param("type") String type);
}
