package com.ruoyi.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.domain.ReviewDetails;
import com.ruoyi.domain.ReviewKeyPoint;
import com.ruoyi.domain.ReviewScene;
import com.ruoyi.domain.ReviewStandard;
import com.ruoyi.mapper.ReviewKeyPointMapper;
import com.ruoyi.service.ReviewKeyPointService;
import com.ruoyi.service.ReviewStandardService;
import com.ruoyi.web.response.ReviewKeyPointNew;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.parameters.P;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ReviewKeyPointServiceImpl extends ServiceImpl<ReviewKeyPointMapper, ReviewKeyPoint> implements ReviewKeyPointService {

    @Autowired
    private ReviewKeyPointMapper reviewKeyPointMapper;

    @Autowired
    private ReviewStandardService reviewStandardService;

    @Override
    public List<ReviewKeyPoint> findByStandardList(List<ReviewStandard> reviewStandardList) {
        return reviewKeyPointMapper.findByStandardList(reviewStandardList);
    }

    @Override
    public ReviewKeyPointNew selectKeypoint(Long id) {
        ReviewKeyPointNew reviewKeyPoint = reviewKeyPointMapper.selectKeypointById(id);
        // 根据检验要点ID (keyPoint.getId()) 查询细则列表
        Long reviewKeypointId = Long.parseLong(reviewKeyPoint.getId());
        List<ReviewDetails> reviewDetailsList = reviewStandardService.selectDetailsListByKeypointId(reviewKeypointId);

        // 将细则列表设置到当前检验要点对象中
        reviewKeyPoint.setReviewDetailsList(reviewDetailsList);

        // 遍历每个细则，并查询审核场景列表
        for (ReviewDetails reviewDetails : reviewDetailsList) {
            // 根据细则ID (reviewDetails.getId()) 查询审核场景列表
            List<ReviewScene> reviewSceneList = reviewStandardService.selectSceneListByDetailsId(reviewDetails.getId());

            // 将审核场景列表设置到当前细则对象中
            reviewDetails.setReviewSceneList(reviewSceneList);

        }
        return reviewKeyPoint;
    }
}
