package com.ruoyi.service.impl;

import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.bean.BeanUtils;
import com.ruoyi.domain.Standard;
import com.ruoyi.domain.StandardInspectionItemRelation;
import com.ruoyi.domain.vo.DictDataVO;
import com.ruoyi.domain.vo.StandardNewVO;
import com.ruoyi.domain.vo.UseCaseNewVO;
import com.ruoyi.mapper.ReviewStandardMapper;
import com.ruoyi.mapper.StandardInspectionItemRelationMapper;
import com.ruoyi.mapper.StandardMapper;
import com.ruoyi.service.StandardInspectionItemRelationService;
import com.ruoyi.service.StandardService;
import com.ruoyi.service.TestUseCaseService;
import com.ruoyi.web.request.*;
import com.ruoyi.web.response.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.*;

@Service
public class StandardServiceImpl extends ServiceImpl<StandardMapper, Standard> implements StandardService {

    @Autowired
    private StandardMapper standardMapper;

    @Autowired
    private StandardService standardService;

    @Autowired
    private StandardInspectionItemRelationMapper standardInspectionItemRelationMapper;

    @Autowired
    private StandardInspectionItemRelationService standardInspectionItemRelationService;

    @Autowired
    private TestUseCaseService testUseCaseService;

    @Autowired
    private ReviewStandardMapper reviewStandardMapper;

    /**
     * 分页查询
     * @param
     * @return
     */
    @Override
    public List<Standard> findList(StandardListRequest request) {
        return standardMapper.findList(request);
    }

    /**
     * 根据id查询
     * @param id
     * @return
     */
    @Override
    public Standard findListById(Long id) {
        return standardMapper.findListById(id);
    }

    @Override
    public void editStandard(StandardEditRequest request) {

        Standard standard = new Standard();
        BeanUtils.copyBeanProp(standard, request);

        List<StandardInspectionItemRelation> list = standardInspectionItemRelationMapper.getListByStandard(request.getId());

        if (list != null && list.size() != 0) {
            standardInspectionItemRelationService.removeBatchByIds(list);
        }

        List<DictDataVO> relations = request.getDictList();
        List<StandardInspectionItemRelation> relationList = new ArrayList<>();

        if (relations != null && relations.size() != 0) {
            for (DictDataVO vo : relations) {
                StandardInspectionItemRelation relation = new StandardInspectionItemRelation();
                relation.setStandardId(request.getId());
                relation.setDictCode(vo.getDictCode());
                relationList.add(relation);
            }

            standardInspectionItemRelationService.saveBatch(relationList);
        }
        standardService.updateById(standard);
    }

    @Override
    public StandardResponse getInfo(StandardGetInfoRequest request) {
        StandardResponse response = new StandardResponse();
        Standard standard = standardMapper.selectById(request.getId());
        List<DictDataVO> list = standardInspectionItemRelationMapper.getListByStandardId(request.getId());
        BeanUtils.copyBeanProp(response, standard);
        response.setDictList(list);
        return response;
    }

    /**
     * 标准库分页查询(可选用标准列表)
     * @param request
     * @return
     */
    @Override
    public List<Standard> findStandardList(StandardListRequest request) {
        return standardMapper.findStandardList(request);
    }


    @Override
    public List<StandardDTO> getStandardDTOList() {
        return standardMapper.getStandardDTOList();
    }

//    @Override
//    public List<StandardDTO> getStandardDTOListAll(List<StandardDTO> standardDTOList) throws IOException {
//
//        for (StandardDTO standardDTO : standardDTOList) {
//            // 创建 GetChapterListRequest 请求对象
//            GetChapterListRequest getChapterListRequest = new GetChapterListRequest();
//            getChapterListRequest.setStandardNo(standardDTO.getStandardNo());
//            getChapterListRequest.setStandardId(standardDTO.getId());
//            getChapterListRequest.setName(standardDTO.getName());
//
//            List<StandardTypeListResponse> standardTypeListResponseList = reviewStandardMapper.getType(getChapterListRequest);
//
////            List<StandardTypeListResponse> typeList = standardDTO.getTypeList();
//
//            // 1. 查询每个标准的类型列表
//            List<StandardTypeListResponse> standardTypeListResponseList = reviewStandardMapper.getType(getChapterListRequest);
//
//            reviewStandardMapper.selectCount();
//
//            // 2. 去重处理类型列表 (使用Set进行去重)
//            Set<String> uniqueTypes = new HashSet<>();
//            List<StandardTypeListResponse> uniqueTypeList = new ArrayList<>();
//
//            for (StandardTypeListResponse standardTypeListResponse : standardTypeListResponseList) {
//                // 判断type是否已经存在，如果不存在则添加到Set中
//                if (uniqueTypes.add(standardTypeListResponse.getType())) {
//                    uniqueTypeList.add(standardTypeListResponse); // 将不重复的类型加入新的列表
//                }
//            }
//
//
//
//
//            // 3. 遍历去重后的类型列表，获取对应的章节集合
//            for (StandardTypeListResponse uniqueStandardType : uniqueTypeList) {
//                GetChapterListRequest getChapterListRequest1 = new GetChapterListRequest();
//                getChapterListRequest1.setStandardId(standardDTO.getId());
//                getChapterListRequest1.setStandardType(uniqueStandardType.getType());
//
//                // 查询该类型对应的章节集合
//                List<ReviewStandardChapterListResponse> reviewStandardChapterListResponseList = reviewStandardMapper.getChapterListByType(getChapterListRequest1);
//
//                // 将查询到的章节信息赋值给当前的 StandardTypeListResponse 对象
//                uniqueStandardType.setReviewStandardChapterListResponses(reviewStandardChapterListResponseList);
//            }
//
//            // 4. 将查询到的标准类型列表赋值给当前的 StandardDTO 对象
//            standardDTO.setTypeList(uniqueTypeList);
//            // 5. 调用第三方接口获取 "test" 类型数据
//            GetUseCaseRequest getUseCaseRequest = new GetUseCaseRequest();
//
//            Offset offset = new Offset();
//            offset.setOffset(0);
//            offset.setLimit(9999);
//            getUseCaseRequest.setOffset(offset);
//
//            SearchFields searchFields = new SearchFields();
//            searchFields.setRequirements("");
//            searchFields.setSerialNumber("");
//            getUseCaseRequest.setSearchFields(searchFields);
//
//            getUseCaseRequest.setName(standardDTO.getName());
//
//            // 6. 将请求转换为 JSON 字符串并调用第三方服务
//            String s = JSONUtil.toJsonStr(getUseCaseRequest);
//            TestStandardListResponse standardList = testUseCaseService.getStandardList(s);
//
//            // 7. 将 TestStandardListResponse 转换为 StandardTypeListResponse
//            if (standardList != null && standardList.getStandards() != null) {
//                StandardTypeListResponse testType = new StandardTypeListResponse();
//                testType.setType("test");
//
//                List<ReviewStandardChapterListResponse> testChapterList = new ArrayList<>();
//                for (StandardNewVO standardNewVO : standardList.getStandards()) {
//                    ReviewStandardChapterListResponse reviewChapter = new ReviewStandardChapterListResponse();
//                    reviewChapter.setStandardId(standardDTO.getId());  // 将标准ID设置为当前DTO的ID
//                    reviewChapter.setChapter(standardNewVO.getSerialNumber());  // 将章节号映射到 serialNumber
//                    reviewChapter.setText(standardNewVO.getRequirements());    // 将章节内容映射到 requirements
//                    reviewChapter.setType("test");   // 设置类型为 "test"
//
//                    testChapterList.add(reviewChapter);
//                }
//
//                // 将转换后的章节信息赋值给 testType
//                testType.setReviewStandardChapterListResponses(testChapterList);
//
//                // 将 "test" 类型的对象添加到 typeList 中
//                uniqueTypeList.add(testType);
//            }
//        }
//
//        // 返回填充完毕的标准列表
//        return standardDTOList;
//    }

    @Override
    public List<StandardDTO> getStandardListNew() throws IOException {

        List<StandardDTO> standardList = standardMapper.getStandardDTOList();

        List<StandardInspectionItemRelation> vos = standardInspectionItemRelationMapper.findList(standardList);

        for (StandardDTO standard : standardList) {
            List<StandardInspectionItemRelation> relationList = new ArrayList<>();
            List<StandardTypeListResponse> typeListResponses = new ArrayList<>();

            StandardTypeListResponse responseSystem = new StandardTypeListResponse();
            responseSystem.setType("system");
            responseSystem.setReviewStandardChapterListResponses(new ArrayList<>());
            typeListResponses.add(responseSystem);

            StandardTypeListResponse responseCar = new StandardTypeListResponse();
            responseCar.setType("car");
            responseCar.setReviewStandardChapterListResponses(new ArrayList<>());
            typeListResponses.add(responseCar);

            StandardTypeListResponse responseTest = new StandardTypeListResponse();
            responseTest.setType("test");
            responseTest.setReviewStandardChapterListResponses(new ArrayList<>());
            typeListResponses.add(responseTest);

            for (StandardInspectionItemRelation relation : vos) {
                if (Objects.equals(relation.getStandardId(), standard.getId())) {
                    relationList.add(relation);

                }
            }

            for (StandardInspectionItemRelation item : relationList) {

                if (item.getDictCode() == 150) {
                    // car
                    GetChapterListRequest getChapterListRequest = new GetChapterListRequest();
                    getChapterListRequest.setStandardType("car");
                    getChapterListRequest.setStandardId(item.getStandardId().toString());
                    List<ReviewStandardChapterListResponse> reviewStandardChapterListResponseList = reviewStandardMapper.getChapterListByType(getChapterListRequest);
                    for (StandardTypeListResponse response : typeListResponses) {
                        if (Objects.equals(response.getType(), "car")) {
                            response.setReviewStandardChapterListResponses(reviewStandardChapterListResponseList);
                        }
                    }
                }
                if (item.getDictCode() == 151) {
                    // test
                    GetUseCaseRequest getUseCaseRequest = new GetUseCaseRequest();
                    Offset offset = new Offset();
                    offset.setOffset(0);
                    offset.setLimit(9999);
                    getUseCaseRequest.setOffset(offset);

                    SearchFields searchFields = new SearchFields();
                    searchFields.setRequirements("");
                    searchFields.setSerialNumber("");
                    getUseCaseRequest.setSearchFields(searchFields);

                    getUseCaseRequest.setName(standard.getName());

                    // 将请求转换为 JSON 字符串并调用第三方服务
                    String s = JSONUtil.toJsonStr(getUseCaseRequest);
                    TestStandardListResponse standardList1 = testUseCaseService.getStandardList(s);

                    // 将 TestStandardListResponse 转换为 StandardTypeListResponse
                    if (standardList1 != null && standardList1.getStandards() != null) {
                        List<ReviewStandardChapterListResponse> reviewStandardChapterListResponseList = new ArrayList<>();

                        // 遍历 TestStandardListResponse 中的 standards 并转换为 ReviewStandardChapterListResponse
                        for (StandardNewVO standardNew : standardList1.getStandards()) {
                            // 检查是否有 useCases
                            if (standardNew.getUseCases() != null && !standardNew.getUseCases().isEmpty()) {
                                for (UseCaseNewVO useCase : standardNew.getUseCases()) {
                                    ReviewStandardChapterListResponse chapterResponse = new ReviewStandardChapterListResponse();

                                    // 设置章节号和章节内容
                                    chapterResponse.setStandardId(standardNew.getId());  // 设置标准号id
                                    chapterResponse.setChapter(standardNew.getSerialNumber()); // 设置章节号
                                    chapterResponse.setText(standardNew.getRequirements()); // 设置章节内容为标准要求

                                    // 可根据实际需求设置类型
                                    chapterResponse.setType("test");

                                    // 将转换后的对象加入列表
                                    reviewStandardChapterListResponseList.add(chapterResponse);
                                }
                            } else {
                                // 如果没有 useCases，则创建一个默认的 ReviewStandardChapterListResponse
                                ReviewStandardChapterListResponse chapterResponse = new ReviewStandardChapterListResponse();

                                chapterResponse.setStandardId(standardNew.getId());  // 设置标准号id
                                chapterResponse.setChapter(standardNew.getSerialNumber()); // 设置章节号
                                chapterResponse.setText(standardNew.getRequirements()); // 设置章节内容为标准要求

                                chapterResponse.setType("test");

                                // 将转换后的对象加入列表
                                reviewStandardChapterListResponseList.add(chapterResponse);
                            }
                        }

                        // 将转换后的列表设置到相应的 StandardTypeListResponse 中
                        for (StandardTypeListResponse response : typeListResponses) {
                            if (Objects.equals(response.getType(), "test")) {
                                response.setReviewStandardChapterListResponses(reviewStandardChapterListResponseList);
                            }
                        }
                    }

                }

                if (item.getDictCode() == 152) {
                    // system
                    GetChapterListRequest getChapterListRequest = new GetChapterListRequest();
                    getChapterListRequest.setStandardType("system");
                    getChapterListRequest.setStandardId(item.getStandardId().toString());
                    List<ReviewStandardChapterListResponse> reviewStandardChapterListResponseList = reviewStandardMapper.getChapterListByType(getChapterListRequest);
                    for (StandardTypeListResponse response : typeListResponses) {
                        if (Objects.equals(response.getType(), "system")) {
                            response.setReviewStandardChapterListResponses(reviewStandardChapterListResponseList);
                        }
                    }
                }

            }

            standard.setTypeList(typeListResponses);



        }


        return standardList;
    }
}
