package com.ruoyi.service.impl;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.domain.TTestPlanRecord;
import com.ruoyi.domain.vo.ItemsByUseCaseVO;
import com.ruoyi.domain.vo.UseCaseUrlVO;
import com.ruoyi.service.TTestPlanRecordService;
import com.ruoyi.mapper.TTestPlanRecordMapper;
import com.ruoyi.web.request.TestPlanRecordGetInfoRequest;
import com.ruoyi.web.request.TestPlanRecordPageRequest;
import okhttp3.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
* @author W_YI
* @description 针对表【t_test_plan_record】的数据库操作Service实现
* @createDate 2024-08-30 10:19:52
*/
@Service
public class TTestPlanRecordServiceImpl extends ServiceImpl<TTestPlanRecordMapper, TTestPlanRecord>
    implements TTestPlanRecordService{

    @Autowired
    private TTestPlanRecordMapper tTestPlanRecordMapper;

    @Override
    public int insertTestPlanRecord(TTestPlanRecord tTestPlanRecord){
        tTestPlanRecord.setTestOrganizationId(SecurityUtils.getDeptId());
        tTestPlanRecord.setCreateTime(new Date());
        return tTestPlanRecordMapper.insert(tTestPlanRecord);
    }

    @Override
    public TTestPlanRecord selectTestPlanRecordDetails(Long id){
        return tTestPlanRecordMapper.selectTestPlanRecordDetails(id);
    }

    @Override
    public List<TTestPlanRecord> selectTestPlanRecordPage(TestPlanRecordPageRequest testPlanRecordPageRequest){
        Long roleId  =  SecurityUtils.getLoginUser().getUser().getRoleId();
        if(roleId.equals(113)){
            testPlanRecordPageRequest.setTestOrganizationId(SecurityUtils.getDeptId());
        }
        return tTestPlanRecordMapper.selectTestPlanRecordPage(testPlanRecordPageRequest);
    }

    @Override
    public int updateTestPlanRecord(TestPlanRecordGetInfoRequest testPlanRecordGetInfoRequest){
        return tTestPlanRecordMapper.updateTestPlanRecord(testPlanRecordGetInfoRequest);
    }

    @Override
    public List getCarTestDetail(String request) throws IOException {

        OkHttpClient client = new OkHttpClient().newBuilder()
                .build();
        MediaType mediaType = MediaType.parse("application/json");
        RequestBody body = RequestBody.create(mediaType, "{\"query\":\"query regulationItemsByUseCase($regulationName:String!$matchUseCases:[String!]!){regulationByName(name:$regulationName){itemsByUseCase(match:$matchUseCases){id serialNumber requirements useCases{id displayID customizedID class name description remediation requirements riskLevel method{name}scenario{name}}}}}\",\"variables\":"+request+"}");
        Request requestKs = new Request.Builder()
                .url("http://10.12.48.80:8089/api/query")
                .method("POST", body)
                .addHeader("Content-Type", "application/json")
                .addHeader("Authorization", "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJleHAiOjAsInRva2VuaWQiOjYxLCJ0eXBlIjoiYXBpIiwidXNlcm5hbWUiOiJhZG1pbiJ9.48Ggjx-FtOcecf73vAHn0XglwgLXZlfXxhXiLDHWWQE")
                .build();
        Response response = client.newCall(requestKs).execute();
        String string = response.body().string();
        JSONObject jsonObject = JSONObject.parseObject(string);
//        List listUseCase = new ArrayList();
        List listUseCase = jsonObject.getJSONObject("data").getJSONObject("regulationByName").getList("itemsByUseCase", ItemsByUseCaseVO.class);

        return listUseCase;

    }
}




