package com.ruoyi.web;


import com.ruoyi.common.core.domain.R;
import com.ruoyi.domain.TestObjectData;
import com.ruoyi.service.TestObjectDataService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.skywalking.apm.toolkit.trace.Tag;
import org.apache.skywalking.apm.toolkit.trace.Tags;
import org.apache.skywalking.apm.toolkit.trace.Trace;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;
import java.util.stream.Collectors;

@Api(tags = "制定检测方案")
@RestController
@RequestMapping("/Object/Data")
public class TestObjectDataController {
    @Autowired
    private TestObjectDataService testObjectDataService;


    @ApiOperation("获取制定方案列表")
    @Trace
    @Tags({@Tag(key = "param", value = "arg[0]"), @Tag(key = "result", value = "returnedObj")})
    @RequestMapping(method = RequestMethod.POST, value = "/getList")
    public R<List> SelectTestObjectDataList(){
      List<TestObjectData>  objectList  =  testObjectDataService.selectTestObjectDataList();
        Map<String, List<TestObjectData>> groupedObject = objectList.stream().collect(Collectors.groupingBy(TestObjectData::getDescribe,LinkedHashMap::new, Collectors.toList()));
        List list= new ArrayList<>();
        final int[] sum = {0};
        groupedObject.forEach((key,value)->{
            Map map=new HashMap();
            map.put("describe",value.get(0).getDescribe());
            map.put("type",value.get(0).getType());
            map.put("key", String.valueOf(sum[0]));
            Map mapObj =new HashMap();
            mapObj.put("options",value);
            map.put("componentProps",mapObj);
            list.add(map);
            sum[0] = sum[0] +1;
        });
        return R.ok(list);

    }

}
